package com.company.demo1.view.parententity;

import com.company.demo1.entity.ChildEntity;
import com.company.demo1.entity.ParentEntity;

import com.company.demo1.entity.Type;
import com.company.demo1.service.TypeService;
import com.company.demo1.view.childentity.ChildEntityDetailView;
import com.company.demo1.view.main.MainView;

import com.vaadin.flow.router.Route;
import io.jmix.flowui.DialogWindows;
import io.jmix.flowui.component.combobox.JmixComboBox;
import io.jmix.flowui.component.grid.DataGrid;
import io.jmix.flowui.kit.action.ActionPerformedEvent;
import io.jmix.flowui.model.CollectionPropertyContainer;
import io.jmix.flowui.model.DataContext;
import io.jmix.flowui.model.InstanceLoader;
import io.jmix.flowui.view.*;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.HashSet;
import java.util.List;

@Route(value = "parentEntities/:id", layout = MainView.class)
@ViewController("demo1_ParentEntity.detail")
@ViewDescriptor("parent-entity-detail-view.xml")
@EditedEntityContainer("parentEntityDc")
public class ParentEntityDetailView extends StandardDetailView<ParentEntity> {
    @Autowired
    private TypeService typeService;
    @ViewComponent
    private JmixComboBox<String> typeField;
    @Autowired
    private DialogWindows dialogWindows;
    @ViewComponent
    private DataContext dataContext;
    @ViewComponent
    private DataGrid<ChildEntity> childEntityDataGrid;
    @ViewComponent
    private InstanceLoader<ParentEntity> parentEntityDl;
    @ViewComponent
    private CollectionPropertyContainer<ChildEntity> childEntityDc;

    @Subscribe
    public void onInit(final InitEvent event) {
        List<String> typeList = typeService.getTypeList();
        typeField.setItems(typeList);
    }

    @Subscribe("childEntityDataGrid.create")
    public void onChildEntityDataGridCreate(final ActionPerformedEvent event) {
        DialogWindow<ChildEntityDetailView> dialogWindow = dialogWindows.detail(this, ChildEntity.class)
                .withViewClass(ChildEntityDetailView.class)
                .newEntity()
                .withParentDataContext(dataContext)
                .withAfterCloseListener(afterCloseEvent->{
                    if (afterCloseEvent.closedWith(StandardOutcome.SAVE)) {
                        ChildEntity ce = afterCloseEvent.getView().getEditedEntity();
                        ce.setParentEntity(getEditedEntity());
                        childEntityDc.getMutableItems().add(ce);
                    }
                })
                .build();
        dialogWindow.getView().setType(typeField.getValue());
        dialogWindow.open();
    }

    @Subscribe("childEntityDataGrid.edit")
    public void onChildEntityDataGridEdit(final ActionPerformedEvent event) {
        DialogWindow<ChildEntityDetailView> window =
                dialogWindows.detail(this, ChildEntity.class)
                        .withViewClass(ChildEntityDetailView.class)
                        .editEntity(childEntityDataGrid.getSingleSelectedItem())
                        .withParentDataContext(dataContext)
                        .withAfterCloseListener(afterCloseEvent->{
                            if (afterCloseEvent.closedWith(StandardOutcome.SAVE)) {
                                childEntityDc.replaceItem(afterCloseEvent.getView().getEditedEntity());
                            }
                        })
                        .build();
        window.getView().setType(typeField.getValue());
        window.open();
    }


    
    

}